//
//  Typumwandlung.java
//  

//	byte, short, int, long
//	float, double
//	char, boolean
//	String

class TypeConversion {
	
	// declare and initialize instance variables for all primitive data types
	byte _byte			= 122;
	short _short		= 32461;
	int _int			= 2147483621;
	long _long			= 352647284671l;	// l identifies the literal as long
	float _float		= 3.14159265f;
	double _double		= 3.14159265;
	char _char			= 'g';
	boolean _boolean	= false;	
	

	// implicit or explicit type conversion ?
	void convertVariables () {
		_byte = (byte) _short;
		_byte = (byte) _int;
		_byte = (byte) _long;
		_byte = (byte) _float;
		_byte = (byte) _double;
		_byte = (byte) _char;
		//_byte = _boolean;
		
		_short = _byte;
		_short = (short) _int;
		_short = (short) _long;
		_short = (short) _float;
		_short = (short) _double;
		_short = (short) _char;
		//_short = _boolean;

		_int = _byte;
		_int = _short;
		_int = (int) _long;
		_int = (int) _float;
		_int = (int) _double;
		_int = _char;
		//_int = _boolean;
		
		_long = _byte;
		_long = _short;
		_long = _int;
		_long = (long) _float;
		_long = (long) _double;
		_long = _char;
		//_long = _boolean;

		_float = _byte;
		_float = _short;
		_float = _int;
		_float = _long;
		_float = (float) _double;
		_float = _char;
		//_float = _boolean;

		_double = _byte;
		_double = _short;
		_double = _int;
		_double = _long;
		_double = _float;
		_double = _char;
		//_double = _boolean;

		// char is only positive !!!
		_char = (char) _byte;
		_char = (char) _short;
		_char = (char) _int;
		_char = (char) _long;
		_char = (char) _float;
		_char = (char) _double;
		//_char = _boolean;

		// you cannot convert boolean
		//_boolean = _byte;
		//_boolean = _short;
		//_boolean = _int;
		//_boolean = _long;
		//_boolean = _float;
		//_boolean = _double;
		//_boolean = _char;
	}
	

	// we don't need an extra class for main
	public static void main (String[] args) {
		// instantiate a new TypeConversion object
		TypeConversion allTypes = new TypeConversion ();

		// Aufgabe (a)
		// convert the variables
		allTypes.convertVariables ();
		
		// Aufgabe (b)
		// float and double
		System.out.println ();
		float floatPi	= 3.14159265f;
		double doublePi	= 3.14159265;		
		System.out.println ("floatPi hat den Wert " + floatPi);
		System.out.println ("doublePi hat den Wert " + doublePi);
	
		// Aufgabe c
		// short to byte
		short kurz = 32461;
		byte nochKuerzer = (byte) kurz;
		System.out.println ("Die Short-Variable kurz hat den Wert " + kurz);
		System.out.println ("Die Byte-Variable nochKuerzer hat den Wert " + nochKuerzer);
		System.out.println ();		
	}
}