//
// Das WildeTiere-Beispiel aus der Vorlesung.
// Alle Klasssen fr das Programm sind in einer einzigen Datei enthalten.
//

// Die Klasse WildeTiereStarter haben wir umbenannt.
// Sie heisst jetzt nur noch WildeTiere ohne Starter.
// Trotzdem startet das Programm noch von hier.
public class WildeTiere {
	public static void main (String[] args) { 
		// Ein Zoo-Objekt erstellen und die Methode losGehts() aufrufen
		Zoo zoo = new Zoo();
		zoo.losGehts();
	}
} 


// Der Zoo managt die wilden Tiere und reagiert auf die Benutzereingabe.
class Zoo {

	// Tier-Objekte erzeugen und Benutzereingabe abfragen
	public void losGehts () { 
		// Tier-Objekte erzeugen
		Affe affe = new Affe ();
		Loewe loewe = new Loewe ();
		Baer baer = new Baer ();
		Hase hase = new Hase ();

		// Die Instanzvariablen fuer jedes Tier mit sinnvollen Werten initialisieren
		affe.setTierart ("Affe");
		affe.setHerkunftsland ("Brasilien");
		affe.setAlter (5);
		affe.setGeschlecht ("maennlich");
		affe.setName ("Tarzan");
		
		loewe.setTierart ("Loewe");
		loewe.setHerkunftsland ("Kenia");
		loewe.setAlter(13);
		loewe.setGeschlecht("weiblich");
		loewe.setName ("Lisa");

		baer.setTierart ("Baer");
		baer.setHerkunftsland ("Polen");
		baer.setAlter (20);
		baer.setGeschlecht("weiblich");
		baer.setName ("Susie");
		
		hase.setTierart ("Hase");
		hase.setHerkunftsland ("Belgien");
		hase.setAlter (3);
		hase.setGeschlecht ("maennlich");
		hase.setName ("Hase");
		
		// BenutzerEingabe-Objekt erstellen 
		Benutzereingabe eingabe = new Benutzereingabe ();

		// hier speichern wir die Auswahl des Benutzers
		String gewaehltesTier;
		
		System.out.println ("Sie sind im Zoo und laufen herum. Beruehren Sie ein Tier mit Ihrer Tastatur, damit Ihnen dieses Tier etwas ueber sich erzaehlt:");

		// Hey, wer hat gesagt, da do-while-Schleife keinen Sinn machen?
		do {
			// Eingabe von der Tastatur speichern
			gewaehltesTier = eingabe.getBenutzereingabe ("Was beruehren Sie: Affe, Loewe, Baer, Hase oder ENDE?");
			
			// Oh nee, schon wieder if-Verzweigungen?
			// Wann bringen die endlich die switch-case-Anweisung in der Vorlesung?
			
			if (gewaehltesTier.equals ("Affe")) {
				affe.erzaehlWas ();
			} else if (gewaehltesTier.equals ("Loewe")) {
				loewe.erzaehlWas ();
			} else if (gewaehltesTier.equals ("Baer")) {
				baer.erzaehlWas ();
			} else if (gewaehltesTier.equals ("Hase")) {
				hase.erzaehlWas ();
			}
		} while (!gewaehltesTier.equals ("ENDE"));
	}
}


// Die Superklasse vererbt die gemeinsamen Instanzvariablen und Methoden fuer alle Tiere.
class Tier {
	// Instanzvariablen
	private String tierart;
	private String herkunftsland;
	private int alter;
	private String geschlecht;
	private String name;

	// Methoden
	
	// Infos ueber die Tiere ausgeben
	public void erzaehlWas () {
		System.out.println ("Mein Name ist " + name + ".");		
		System.out.println ("Ich bin ein " + tierart + ".");
		System.out.println ("Ich komme aus " + herkunftsland + ".");
		System.out.println ("Mittlerweile bin ich " + alter + " Jahre jung.");
		System.out.println ("Und ich bin " + geschlecht + ".");
		System.out.println ();
	}

	// in dieser Uebung machen Tiere noch keine Geraeusche
	public void geraeuschMachen () {
	}
	
	
	// Getter und Setter
	public void setTierart (String art) {
		tierart = art;
	}

	public String getTierart () {
		return tierart;
	}	
	
	public void setHerkunftsland (String herkunft) {
		herkunftsland = herkunft;
	}
	
	public String getHerkunftsland () {
		return herkunftsland;
	}
	
	public void setAlter (int jahre) {
		alter = jahre;
	}
	
	public int getAlter () {
		return alter;
	}
	
	public void setGeschlecht (String sex) {
		geschlecht = sex;
	}
	
	public String getGeschlecht () {
		return geschlecht;
	}
	
	public void setName (String manNenntMich) {
		name = manNenntMich;
	}
	
	public String getName () {
		return name;
	}
} 


// diese Klassen erben alle von der Superklasse Tier
class Affe extends Tier {
}

class Loewe extends Tier {
}

class Baer extends Tier {
}

class Hase extends Tier {
}